; Assembly Source File
; Created 07/03/2002, 22:00:48
; Juggle, par Emeric Dupont

;Fichiers partags
	include "doorsos.h"
	include "util.h"
	include	"graphlib.h"
	xdef	_main
	xdef	_comment
	xdef	_ti92plus
	
;Constantes (part=16; width=128)
Partlog	EQU	4	;log(Part)
PL2	EQU	8	;2Partlog
Part1	EQU	15	;part-1
U	EQU	16	;Width/8
U2	EQU	32	;2U
WP	EQU	2	;log(Width/Part)
U112	EQU	96	;112-U

;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    Macros - Routines    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Setfont: Dfinit la taille des caractres
setfont	macro			;taille (012)
	move.w	\1,-(a7)
	jsr	doorsos::FontSetSys
	addq.l	#2,a7
	endm	

Ecrire MACRO				; Syntax : x/y/Color/String
	move.w \3,-(a7)			;we put the color in the Stack.
	pea \4(PC)			;we put the String to Display in the Stack.
	move.w \2,-(a7)			;we put the Y-coordinate in the Stack.	
	move.w \1,-(a7)			;we put the X-coordinate in the Stack.	
	jsr doorsos::DrawStrXY		;we call the subroutine in TIOS.
	lea 10(a7),a7			;we restore the Stack of 10 = 2+4+2+2
	ENDM



;macro putball  16*16  eor
;place balle dans le buffer en x(col),y(lig)
;registres dtruits: a6,a5
;Utilisation: Putball X,Y,ball(ou xball)

Putball	macro
	move.w	\1,d0
	move.w	\2,d1
	lea	\3(pc),a0
	jsr	graphlib::put_sprite
	endm

FindBall macro	; renvoie position x=d4 et y=d7;dtruit d4,d7; infos sur les balles en d6
;	move.w	#112,d7		;x0=112+uE     E=1 si d; E=-1 si g (d/g pour le dpart!)
;	sub.w	#U,d7		;on considre que E=-1. on a x0=112+UE
	move.w	#U112,d7	;on remplace les deux instructions prcdentes par (112-U)->d7
	btst	#9,d6		;vrification
	beq	\gauche		;si E=-1, tant mieux
	add.w	#U2,d7		;sinon, on corrige
\gauche:			;et on continue
	move.b	d7,x0
	move.b	d6,cball	;on sauve code balle
	move.b	d6,d7		;code en d7
	lsl.w	#Partlog,d7	;CP en d7
	swap	d6
	sub.b	d6,d7
	mulu	d6,d7		;t(CP-t)->d7
	move.b	cm2,d4
	divu	d4,d7		
	mulu	#435,d7
	lsr.w	#PL2,d7
	move.b	#110,d4
	sub.b	d7,d4
	move.b	d4,yball	;y(t)=110-t(cp-t)/cm*440/p
	move.w	d6,d7
	lsl.w	#WP,d7
	move.b	cball,d4
	divu	d4,d7		;d7=tW/CP (=vt)
	move.b	x0,d4
	btst	#16,d6		;code pair ou impair?
	beq	\pair		;si pair, cf plus loin
	add.b	d7,d4		;on considre que E=-1 (ici,d7=vt). On a x(t)=x0-vtE si c impair
	btst	#25,d6		;on vrifie
	beq	\finm		;si juste, tant mieux
	sub.b	d7,d4
	sub.b	d7,d4		;sinon, on corrige
	bra	\finm
\pair:
	lsr.b	#2,d7
	sub.b	d7,d4		;on considre que E=-1 (ici,d7=vt). On a x(t)=x0+Evt/4
	btst	#25,d6		;on vrifie
	beq	\finm		;si juste, tant mieux
	add.b	d7,d4
	add.b	d7,d4		;sinon, on corrige
\finm:
	move.b	cball,d0
	cmp.b	#2,d0		;si code 2, balle garde
	bne	\lancee
	move.b	#110,yball
	move.b	x0,d4
\lancee:
	move.b	yball,d7	;en sortie, d4=x et d7=y
	endm

Shiftsequence	macro		;shifte la squence siteswap vers la gauche; dtruit a6,d4,d7
	cmp.b	#1,d6		;si un seul chiffre, pas  shifter
	beq	\mono
	move.w	d6,d3
	and.l	#$ffff,d3
	subq.w	#2,d3
;	move.b	(a6),d7		;on a dj d7.b=(a6)
\shift:
	move.b	1(a6),(a6)+
	dbra	d3,\shift
	move.b	d7,(a6)
\mono:
	endm

Bcpy	macro			;#bit,dX,#bit,dY;copie les bits
	bclr	\3,\4		;on suppose 0
	btst	\1,\2		;on vrifie
	beq	\copie		;si juste, tant mieux
	bset	\3,\4		;sinon, on corrige
\copie:
	endm

Chifreg	macro			;registre(valeur<10) pour debug
	move.l	d2,-(a7)
	move.b	\1,debug
	add.b	#48,debug
	Ecrire	#0,#30,#4,debug
	jsr	util::idle_loop
	move.l	(a7)+,d2
	endm

;;;;;;;;;;;;;;;;;;;;;;;
;        CODE         ;
;;;;;;;;;;;;;;;;;;;;;;;

_main:
;Entre chane
	move.l	#7,d6
	lea	sequence(pc),a6	
	add.l	#32,a6
\EffaceSeq:
	move.l	#0,-(a6)	;on efface un dword
	dbra	d6,\EffaceSeq	;puis on recommence
	setfont	#2
	jsr	util::zap_screen
	Ecrire	#0,#100,#4,_comment
	eor.l	d6,d6		;compteur de caractres  0 (max 32)
\BoucleEntreChaine:
	jsr	util::idle_loop	;rcupre touche
	cmp.b	#13,d0		;si entre, fin de saisie
	beq	\FinEntreeChaine
	cmp.w	#264,d0		;si esc, on quitte
	beq	exit
	cmp.w	#257,d0		;si backspace, on corrige
	bne	\nobs
	cmp.b	#0,d6		;si backspace avant la saisie, 
	beq	\BoucleEntreChaine	;on n'en tient pas compte
	move.b	#32,-(a6)	;on efface le prcdent, et on pointe dessus
	subq.b	#1,d6		;un chiffre en moins
	bra	\bs
\nobs:
	cmp.b	#32,d6		;si 32 chiffres
	beq	\BoucleEntreChaine	;on refuse l'entre d'un autre
	cmp.w	#65,d0		;si A
	beq	\ab		;on en tient compte
	cmp.w	#66,d0		;si B
	beq	\ab		;on en tient compte
	cmp.w	#97,d0		;si a
	beq	\ab		;on en tient compte
	cmp.w	#98,d0		;si b
	beq	\ab		;on en tient compte
	cmp.w	#48,d0		;si <0, on retourne
	blt	\BoucleEntreChaine
	cmp.w	#58,d0		;si >9, on retourne
	bgt	\BoucleEntreChaine
\ab:				
	add.b	#1,d6		;on compte les chiffres
	move.b	d0,(a6)+	;et on le met  la suite
\bs:				;affiche si backspace
	Ecrire	#0,#0,#4,sequence
	bra	\BoucleEntreChaine
\FinEntreeChaine:
;Faisabilit
	move.b	d6,d5		;sauve la priode
	subq.b	#1,d5		;priode-1: nombre d'additions
	and.l	#$ff,d5
	eor.b	d7,d7		;d7: variable de sommation
	lea	sequence(pc),a6
	eor.l	d3,d3		;pour le max
\somme:
	sub.b	#48,(a6)	;on convertit en chiffres
	cmp.b	#10,(a6)
	ble	\converti	;si <10, converti
	sub.b	#7,(a6)
	cmp.b	#12,(a6)
	ble	\converti	;sinon, on enlve le ncessaire
	sub.b	#32,(a6)
\converti:
	cmp.b	(a6),d3		;recherche du max
	bge	\max
	move.b	(a6),d3
\max:
	add.b	(a6)+,d7	;ajoute, et pointe au suivant
	dbra	d5,\somme
\finsomme:
	cmp.b	#0,d7
	bne	\dif0
	setfont	#1
	Ecrire	#0,#10,#4,noball
	bra	\quit
\dif0:
	move.b	d3,cm
	and.l	#$ff,d7
	and.l	#$ff,d6
	divu	d6,d7		;moyenne des chiffres=nbre de balles(partie entire)
	move.b	d7,d5		;d5=nbre de balles; lg sur 8-15
	and.l	#$ffff0000,d7	;conservation du reste
	beq 	\permutation	;si entier, test de permutation
	setfont	#1
	Ecrire	#0,#10,#4,moyenne
	bra	\quit		;sinon, non jonglable
\permutation:			;a6 pointe sur la fin de sequence
	move.b	d6,d3		;prpare compteur
	subq.b	#1,d3
	eor.l	d4,d4		;efface permuteur
\testperm:
	move.b	-(a6),d7	;rcupre chiffre
	add.b	d3,d7		;on ajoute le rang
	and.l	#$ff,d7
	divu	d6,d7
	swap	d7		;d7 recoit le reste
	and.l	#$ffff,d7
	bset	d7,d4
	beq	\permok
	setfont	#1
	Ecrire	#0,#10,#4,noperm
	bra	\quit
\permok:
	dbra	d3,\testperm
;Animation
	lea 	balles(pc),a5
	move.l	a5,a4		;ad balles en a5 et a4
	move.b	cm,d7
	mulu	cm,d7
	move.w	d7,cm2		;calcul de cm
	bclr	#8,d5		;changement de main de lancer (dte)
\balarive:
	move.b	(a6),d7		;code en d7
	or.b	#0,d7		;si code 0
	beq	\onshifte	;pas de balle arrive, donc uniquement le shift
\metronome:			;marqueur de chaque temps (part*t)
	move.w	(a5)+,d4	;t->d4
	move.w	(a5)+,d7	;d/g;C->d7; a5 sur balle suivante
	cmp.b	#0,d7		;balle dj lance? (code=0 -> pas de trajectoire -> en main)
	beq	\newinfs	;non? donc on lance cette balle(les autre balles lances ne sont pas arrives). inutile de calculer cp
	and.w	#$FF,d7		;on ne garde que C
	lsl.w	#Partlog,d7	;calcul de CP
	cmp.w	d7,d4		;t=CP?
	bne	\metronome	;non? donc on essaie une autre balle
\newinfs:			;on entre les nouvelles infos sur la balle
	bchg	#8,d5		;changement de main de lancer
	move.b	(a6),-(a5)	;retour sur la balle arrive, et on attribue le nouveau code
	move.b	(a5),d7		;code dans 7
	move.b	-(a5),d4	;d/g->d4; a5 pointe sur d/g
	Bcpy	#8,d5,#1,d4	;main de lancer en d4
\suite:
	move.b	d4,(a5)		;et on rinjecte les donnes sur les mains
	move.w	#0,-(a5)	;dure  0
\onshifte:
	move.l	a6,a5		;on sauve a6
	Shiftsequence		;d7 contient le code de la balle en cours
	move.l	a5,a6		;et on restaure
	move.l	#Part1,d3	;compteur  part-1
	move.w	d6,-(a7)	;on sauve d6
	cmp.b	#0,d7
	bne	\anim
	bchg	#8,d5		;si c=0, la main de lancer n'a pas t change
\anim:
	move.w	d5,-(a7)
	subq.b	#1,d5		;compteur balles
	bclr	#8,d5		;d5 passe sur un octet 
	move.l	a4,a5		;a5 pointe sur les balles
	jsr	util::zap_screen
\balls:				;pour chaque balle:
	move.l	(a5),d6		;-on rcupre les donnes
	cmp.b	#0,d6		;balle en l'air? (code 0 si pas encore lance)
	beq	\enmain
	FindBall		;-on calcule la position si dj lance
	Putball	d4,d7,ball	;on affiche
;Touche ESC?
	move.b	$60001b,d0	;renvoie le bit enregistr dans d0 i.e. bit 1-7
	cmp.b	#$FF,d0		;Esc presse?
	bne	\quitanim	;si oui, on quitte
;Pas touche ESC
	add.w	#1,d6		;on incrmente le compteur (d6 est swapp par Findball)
	swap	d6		;on restaure d6
\enmain:
	move.l	d6,(a5)+	;on rentre les nouvelles infos, et on pointe sur la balle suivante(si existe)
;Temporistation
	move.l	#11,d0
;	sub.b	d5,d0
	move.b	d5,d0
	lsl.w	#5,d0
\wait:
	dbra	d0,\wait
;fin temporisation
	cmp.b	#0,d6		;code = 0? alors les suivantes aussi
	dbeq	d5,\balls	;on fait les d5 balles
	move.w	(a7)+,d5
	and.l	#$ffff,d5	;d5 en mot long car dbra-> (-1)
	dbra	d3,\anim	;on continue tant que pas de balle arrive
	move.w	(a7)+,d6
	move.l	a4,a5
	bra	\balarive	;balle arrive (ou 0)
;sortie
\quitanim:
	lea	4(a7),a7	;on restaure la pile
	bra	exit
\quit:
	jsr	util::idle_loop
exit:
	rts
	
;Variables
debug	dc.b	0
nballs	dc.b	0	;nbr de balles lances
sequence:
	 dc.l	0,0,0,0,0,0,0,0	;pour stocker la squence siteswap
balles:
	dc.l	0,0,0,0,0,0,0,0,0,0,0	;un dword par balle, 11 balles max.
	
x0	dc.w	0
cm	dc.w	0
cm2	dc.w	0	;cm
cball	dc.w	0	;code balle
yball	dc.w	0
ball:
	dc.w	16
	dc.w	2
	dc.b	%00000111,%11000000
	dc.b	%00011000,%00111000
	dc.b	%00110000,%00001100
	dc.b	%01000000,%00011100
	dc.b	%01000000,%00111110
	dc.b	%11000000,%01111110
	dc.b	%11000000,%11111111
	dc.b	%11100000,%11111111
	dc.b	%11100001,%11111111
	dc.b	%11110001,%11111111
	dc.b	%11111011,%11111110
	dc.b	%01111111,%11111110
	dc.b	%01111100,%11111100
	dc.b	%00111100,%01111000
	dc.b	%00001100,%00110000
	dc.b	%00000111,%11000000

xball:
	dc.w	16
	dc.w	2
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
moyenne	dc.b	"Squence invalide: moyenne non entire",0
noperm	dc.b	"Squence invalide: pas une permutation",0
noball	dc.b	"Squence invalide: aucune balle  lancer",0
mpx	dc.b	"Squence invalide: ']' attendu",0 

_comment:	dc.b	"Juggle v1.50 par Emeric Dupont",0
	end
